unit U_FactoryInput;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin, StdCtrls,
  cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, ShellAPI, IniFiles, cxCheckBox, cxCalendar, cxButtonEdit,
  cxTextEdit, cxDropDownEdit, BtnEdit, cxLookAndFeels, cxLookAndFeelPainters,
  cxNavigator, dxSkinsCore, dxSkinsDefaultPainters, dxSkinscxPCPainter,
  cxContainer;

type
  TfrmFactoryInput = class(TForm)
    ToolBar1: TToolBar;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    ToolButton3: TToolButton;
    ToolBar2: TToolBar;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    CDS_LXR: TClientDataSet;
    DSLXR: TDataSource;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    cxGridDBColumn1: TcxGridDBColumn;
    cxGridDBColumn2: TcxGridDBColumn;
    cxGridDBColumn3: TcxGridDBColumn;
    cxGridDBColumn4: TcxGridDBColumn;
    cxGridDBColumn5: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    v3Column2: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    v3Column3: TcxGridDBColumn;
    ToolButton1: TToolButton;
    ScrollBox1: TScrollBox;
    Label2: TLabel;
    Label6: TLabel;
    Label12: TLabel;
    Label39: TLabel;
    Label7: TLabel;
    Label19: TLabel;
    Name: TEdit;
    Address: TEdit;
    Note: TMemo;
    Label1: TLabel;
    shortName: TEdit;
    Code: TEdit;
    area: TEdit;
    Label3: TLabel;
    Gdy: TEdit;
    Label8: TLabel;
    TJNAME: TEdit;
    FactType: TcxButtonEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FactTypePropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
  private
    { Private declarations }
    procedure InitGrid();
    function SaveData(): Boolean;
  public
    fkhType, FGYSNO: string;
    { Public declarations }
    FCOID, fname: string;
  end;

var
  frmFactoryInput: TfrmFactoryInput;

implementation

uses
  U_DataLink, U_Fun, U_ZDYHelp;

{$R *.dfm}

procedure TfrmFactoryInput.InitGrid();
begin
  try

    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      SQL.Clear;
      sql.Add(' select * from BS_Company_Main where  CoType=''供应商'' and COID=''' + Trim(FCOID) + '''');
      Open;
    end;
    SCSHData(ADOQueryMain, ScrollBox1, 2);
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      SQL.Clear;
      sql.Add(' select * from BS_Company_Sub where COID=' + quotedstr(Trim(FCOID)));
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_LXR);
    SInitCDSData20(ADOQueryMain, CDS_LXR);
    Name.SetFocus;
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmFactoryInput.FormDestroy(Sender: TObject);
begin
  frmFactoryInput := nil;
end;

procedure TfrmFactoryInput.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmFactoryInput.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption), Tv1, '供应商管理');
  ModalResult := 1;
end;

procedure TfrmFactoryInput.FormShow(Sender: TObject);
begin
  ReadCxGrid(trim(self.Caption), Tv1, '供应商管理');
  InitGrid();
end;

procedure TfrmFactoryInput.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

function TfrmFactoryInput.SaveData(): Boolean;
var
  MaxId, MaxSubId, FCoCode, FCCID: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    if Trim(FCOID) = '' then
    begin
      if GetLSNo(ADOQueryCmd, MaxId, 'CO', 'BS_Company_Main', 4, 1) = False then
      begin
        Result := False;
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('取最大号失败！', '提示', 0);
        Exit;
      end;
//      自动生成供应商编号
//      if GetLSNo(ADOQueryCmd, FCoCode, 'G', 'Company', 4, 0) = False then
//      begin
//        Result := False;
//        ADOQueryCmd.Connection.RollbackTrans;
//        Application.MessageBox('取最大号失败！', '提示', 0);
//        Exit;
//      end;
//      CoCode.Text := trim(FCoCode);
    end
    else
    begin
      MaxId := Trim(FCOID);
    end;

    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from BS_Company_Main where COID=''' + Trim(FCOID) + '''');
      Open;
    end;
    with ADOQueryCmd do
    begin
      if Trim(FCOID) = '' then
      begin
        Append;
        FieldByName('Filler').Value := Trim(DName);
        FieldByName('FillCode').Value := Trim(DCode);
        FieldByName('filltime').Value := SGetServerDateTime(ADOQueryTemp);
      end
      else
      begin
        Edit;
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('EditCode').Value := Trim(DCode);
        FieldByName('Edittime').Value := SGetServerDateTime(ADOQueryTemp);
      end;
      FieldByName('COID').Value := Trim(MaxId);
      SSetsaveSqlNew(ADOQueryCmd, 'Company', ScrollBox1, 2);
      FieldByName('CoType').Value := '供应商';
      FieldByName('Valid').Value := 'Y';
      if TJNAME.Text = '' then
      begin
        FieldByName('TJNAME').Value := Self.Name.TEXT;
        TJNAME.Text := Self.Name.TEXT;
      end;
      Post;
    end;

//    with ADOQueryCmd do
//    begin
//      Close;
//      sql.Clear;
//      sql.Add('select * from BS_Company_Main where Code=' + quotedstr(trim(Code.Text)));
//      sql.Add(' and CoType=''供应商''  and Valid=''Y''  ');
//      Open;
//    end;
//    if ADOQueryCmd.RecordCount > 1 then
//    begin
//      ADOQueryCmd.Connection.RollbackTrans;
//      Application.MessageBox('供应商编号重复!', '提示', 0);
//      Exit;
//    end;
//
    fname := Name.Text;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from BS_Company_Main where Name=' + quotedstr(trim(fname)));
      sql.Add(' and CoType=''供应商''  and Valid=''Y''  ');
      Open;
    end;
    if ADOQueryCmd.RecordCount > 1 then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('供应商名称重复!', '提示', 0);
      Exit;
    end;
//     添加联系人
    if not CDS_LXR.IsEmpty then
    begin
      with CDS_LXR do
      begin
        CDS_LXR.First;
        while not Eof do
        begin
          FCCID := Trim(CDS_LXR.fieldbyname('CSID').AsString);
          if Trim(FCCID) = '' then
          begin
            if GetLSNo(ADOQueryCmd, MaxSubId, 'CS', 'BS_Company_Sub', 4, 1) = False then
            begin
              ADOQueryCmd.Connection.RollbackTrans;
              Application.MessageBox('取联系人最大ID失败!', '提示', 0);
              Exit;
            end;
          end
          else
          begin
            MaxSubId := trim(FCCID);
          end;

          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from BS_Company_Sub where CSID=' + quotedstr(Trim(MaxSubId)));
            Open;
          end;
          with ADOQueryCmd do
          begin
            if Trim(FCCID) = '' then
            begin
              Append;
            end
            else
            begin
              Edit;
            end;
            FieldByName('CSID').Value := Trim(MaxSubId);
            FieldByName('COID').Value := Trim(MaxId);
            RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_LXR, 'BS_Company_Sub', 0);
            Post;
          end;
          with CDS_LXR do
          begin
            Edit;
            FieldByName('CSID').Value := Trim(MaxSubId);
            Post;
          end;
          CDS_LXR.Next;
        end;
      end;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    FCCID := Trim(MaxSubId);
    Result := True;
  except
    Result := false;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('保存异常!', '提示', 0);
  end;
end;

procedure TfrmFactoryInput.ToolButton3Click(Sender: TObject);
var
  maxorderno: string;
begin
  FGYSNO := Trim(Code.Text);

  if Trim(Code.Text) = '' then
  begin
    if GetLSNo(ADOQueryCmd, maxorderno, 'GYS', 'BS_Company_Main', 3, 1) = False then
    begin
      Application.MessageBox('供应商编号生成失败！', '提示', 0);
      Exit;
    end;
    Code.Text := maxorderno;
  end
  else
    Code.Text := maxorderno + Trim(Code.Text);

  if Trim(Name.Text) = '' then
  begin
    Application.MessageBox('供应商名称不能为空!', '提示', 0);
    Code.Text := FGYSNO;
    Exit;
  end;
  if SaveData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    ModalResult := 1;
  end;
end;

procedure TfrmFactoryInput.ToolButton4Click(Sender: TObject);
var
  maxno: string;
begin
  if GetLSNo(ADOQueryCmd, maxno, 'CC', 'BS_Company_Sub', 4, 1) = False then
  begin
    Application.MessageBox('取系人最大ID失败!', '提示', 0);
    Exit;
  end;
  if CDS_LXR.IsEmpty then
  begin
    with CDS_LXR do
    begin
      Append;
      fieldbyname('CSID').Value := trim(maxno);
      fieldbyname('IsDefault').Value := true;
      Post;
    end;
  end
  else
  begin
    with CDS_LXR do
    begin
      Append;
      fieldbyname('CSID').Value := trim(maxno);
      fieldbyname('IsDefault').Value := false;
      Post;
    end;
  end;

end;

procedure TfrmFactoryInput.ToolButton5Click(Sender: TObject);
begin
  if CDS_LXR.IsEmpty then
    Exit;
  if Trim(CDS_LXR.fieldbyname('CSID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('delete from BS_Company_Sub where CSID=''' + Trim(CDS_LXR.fieldbyname('CSID').AsString) + '''');
      ExecSQL;
    end;
  end;
  CDS_LXR.Delete;
  if CDS_LXR.IsEmpty = false then
  begin
    if CDS_LXR.Locate('IsDefault', true, []) = false then
    begin
      CDS_LXR.first;
      CDS_LXR.edit;
      CDS_LXR.FieldByName('IsDefault').value := true;
    end;
  end;
end;

procedure TfrmFactoryInput.ToolButton1Click(Sender: TObject);
var
  DwFlag: string;
begin
  DwFlag := trim(CDS_LXR.FieldByName('CSID').AsString);
  if CDS_LXR.Locate('IsDefault', true, []) then
  begin
    CDS_LXR.edit;
    CDS_LXR.FieldByName('IsDefault').value := false;
  end;
  if CDS_LXR.Locate('CSID', DwFlag, []) then
  begin
    CDS_LXR.edit;
    CDS_LXR.FieldByName('IsDefault').value := true;
  end;

end;

procedure TfrmFactoryInput.FactTypePropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
var
  fsj: string;
  FWZ: Integer;
begin
  fsj := Trim(TcxButtonEdit(Sender).Hint);
  FWZ := Pos('/', fsj);
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := Copy(fsj, 1, FWZ - 1);
      flagname := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);

      if ShowModal = 1 then
      begin
        TcxButtonEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

end.

